# Command line tools [![Lists](https://img.shields.io/badge/-more%20lists-0a0a0a.svg?style=flat&colorA=0a0a0a)](https://github.com/learn-anything/curated-lists)

_Please read [contribution guidelines](contributing.md) before contributing._

- [CSV](#csv)
- [File system](#file-system)
- [Fun](#fun)
- [Games](#games)
- [Git](#git)
- [Go](#go)
- [Java](#java)
- [Lua](#lua)
- [macOS](#macos)
- [Networking](#networking)
- [Nix](#nix)
- [Package managers](#package-managers)
- [Productivity](#productivity)
- [Python](#python)
- [Ruby](#ruby)
- [Rust](#rust)
- [Static website engines](#static-website-engines)
- [Text editors](#text-editors)
- [Web](#web)
- [Logging](#logging)
- [Other](#other)
- [Related](#related)

## CSV

- [xsv](https://github.com/BurntSushi/xsv) - Fast CSV command line toolkit written in Rust.
- [csvdiff](https://github.com/aswinkarthik/csvdiff) - Fast diff tool for comparing csv files.
- [sc-im](https://github.com/andmarti1424/sc-im) - ncurses spreadsheet program for terminal.

## File system

- [RecoverPy](https://github.com/PabloLec/RecoverPy) - Recover overwritten or deleted data.
- [modd](https://github.com/cortesi/modd) - Flexible tool for responding to filesystem changes.
- [reflex](https://github.com/cespare/reflex) - Run a command when files change.

## Fun

- [primitive](https://github.com/fogleman/primitive) - reproducing images with geometric primitives.

## Games

- [love](https://love2d.org/) - Framework to make 2D games in Lua.

## Git

- [fac](https://github.com/mkchoi212/fac) - Easy-to-use CUI for fixing git conflicts.
- [git](https://www.explainshell.com/explain/git) - The stupid content tracker.
- [hub](https://github.com/github/hub) - Wrapper around Git to extend it with features.
- [tig](https://jonas.github.io/tig/) - Text-mode interface for git.

## Go

- [dep](https://github.com/golang/dep) - Go dependency management tool.
- [go](https://golang.org/doc/cmd) - Manage go source code.
- [playgo](https://github.com/plutov/playgo) - Send .go file to the Go Playground.
- [richgo](https://github.com/kyoh86/richgo) - Enrich `go test` outputs with text decorations.

## Java

- [ant](https://www.explainshell.com/explain/ant) - Java based make tool.
- [java-repl](https://github.com/albertlatacz/java-repl) - Read Eval Print Loop for Java.

## Lua

- [lua](https://www.explainshell.com/explain/lua) - Lua interpreter.
- [luajit](https://www.explainshell.com/explain/luajit) - Just-in-time compiler for the lua language.

## macOS

- [asr](https://ss64.com/osx/asr.html) - Apple Software Restore; copy volumes (e.g. from disk images).
- [defaults](https://ss64.com/osx/defaults.html) - Access user's defaults.
- [do-not-disturb](https://github.com/sindresorhus/do-not-disturb-cli) - Control the macOS `Do Not Disturb` feature.
- [kexstat](https://developer.apple.com/library/archive/documentation/Darwin/Conceptual/KEXTConcept/Articles/command_line_tools.html) - Display status of loaded kernel extensions.
- [m-cli](https://github.com/rgcr/m-cli) - Swiss Army Knife for macOS.
- [PlistBuddy](https://www.unix.com/man-page/osx/8/PlistBuddy/) - Read and write values to plists.
- [softwareupdate](https://www.unix.com/man-page/osx/8/softwareupdate/) - System software update tool.
- [iStats](https://github.com/Chris911/iStats) - Mac stats.
- [mas](https://github.com/mas-cli/mas) - Command line interface for the Mac App Store.
- [time](https://developer.apple.com/library/archive/documentation/System/Conceptual/ManPages_iPhoneOS/man3/time.3.html)
- [switchaudio-osx](https://github.com/deweller/switchaudio-osx) - Change the audio source for Mac OS X from the command line.
- [displayplacer](https://github.com/jakehilborn/displayplacer) - macOS command line utility to configure multi-display resolutions and arrangements. Essentially XRandR for macOS.

## Networking

- [neoss](https://github.com/PabloLec/neoss) - Socket statistics visualization and explanation tool for Unix systems.
- [Catflap](https://github.com/passcod/catflap) - Creates a listening TCP socket and passes its FD to a child process.
- [curlie](https://github.com/rs/curlie) - Power of curl, the ease of use of httpie.
- [sshfs](https://github.com/libfuse/sshfs) - Network filesystem client to connect to SSH servers.
- [sshuttle](https://github.com/sshuttle/sshuttle) - Transparent proxy server that works as a poor man's VPN. Forwards over ssh. Doesn't require admin. Works with Linux and MacOS. Supports DNS tunneling.
- [telnet](https://www.explainshell.com/explain/telnet) - User interface to the TELNET protocol.
- [bandwhich](https://github.com/imsnif/bandwhich) - CLI utility for displaying current network utilization by process, connection and remote IP/hostname.
- [httpie](https://github.com/httpie/httpie) - Modern, user-friendly command-line HTTP client for the API era.
- [http-prompt](https://github.com/httpie/http-prompt) - Interactive command-line HTTP and API testing tool built on top of HTTPie with autocomplete, syntax highlighting, and more.

## Nix

- [nix-env](https://www.mankier.com/1/nix-env) - Manipulate or query Nix user environments.
- [nix-shell](https://nixos.org/nix/manual/) - Start an interactive shell based on a Nix expression.
- [nox](nhttps://github.com/madjar/nox) - Tools to make nix nicer to use.

## Package managers

- [brew](http://docs.brew.sh/) - Package manager for macOS.
- [npm](http://manpages.ubuntu.com/manpages/precise/en/man1/npm.1.html) - Package manager for javascript.
- [yarn](https://yarnpkg.com/lang/en/docs/) - Package manager for javascript.

## Productivity

- [eureka](https://github.com/simeg/eureka) - CLI tool to input and store your ideas without leaving the terminal.

## Python

- [livepython](https://github.com/agermanidis/livepython) - Visually trace python code in real-time.
- [rq](https://github.com/rq/rq) - Simple job queues for Python.
- [tg](https://github.com/paul-nameless/tg) - Telegram terminal client.
- [visa-cli](https://github.com/rand-net/visa-cli) - Visa Requirements terminal interface.

## Ruby

- [rbenv](https://github.com/rbenv/rbenv) - Groom your app’s Ruby environment.
- [ruby-build](https://github.com/rbenv/ruby-build) - Compile and install Ruby.

## Rust

- [project init](https://github.com/vmchale/project-init) - Project templates in rust.
- [rustup](https://github.com/rust-lang-nursery/rustup.rs) - Rust toolchain installer.

## Static website engines

- [hugo](https://gohugo.io/overview/introduction/) - Static site generator written in go.
- [jekyll](https://jekyllrb.com/docs/home/) - Static site generator written in ruby.

## Text editors

- [kakoune](https://github.com/mawww/kakoune) - Modal editor with multi selections.
- [micro](https://github.com/zyedidia/micro) - Modern and intuitive terminal-based text editor.
- [emacs](https://www.explainshell.com/explain/emacs) - Extendable/customizable text editor.
- [neovim](https://github.com/neovim/neovim) - Vim-fork focused on extensibility and usability.
- [vim](https://github.com/vim/vim) - Modal text editor.

## Web

- [create-react-app](https://github.com/facebookincubator/create-react-app) - Create React apps with no build configuration.
- [preact](https://github.com/developit/preact-cli) - Create preact app.
- [up](https://github.com/apex/up) - Deploy infinitely scalable serverless apps, apis, and sites in seconds to AWS.
- [urlsup](https://github.com/simeg/urlsup) - CLI to validate URLs in files.

## Logging

- [lnav](https://github.com/tstack/lnav) - Advanced log file viewer for the small-scale; Watch and analyze your log files from a terminal.
- [red](https://github.com/antonmedv/red) - Terminal log analysis tools.
- [goaccess](https://github.com/allinurl/goaccess) - Real-time web log analyzer and interactive viewer that runs in a terminal in nix systems or through your browser.
- [angle-grinder](https://github.com/rcoh/angle-grinder) - Slice and dice logs on the command line.
- [drep](https://github.com/maxpert/drep) - Grep with dynamic reloadable filter expressions. This allows filtering stream of logs/lines, while changing filters on the fly.

## Other

- [zenith](https://github.com/bvaisvil/zenith) - Sort of like top or htop but with zoom-able charts, network, and disk usage.
- [grcov](https://github.com/mozilla/grcov) - Collects and aggregates code coverage information for multiple source files.
- [wtf](https://github.com/wtfutil/wtf) - Personal information dashboard for your terminal.
- [navi](https://github.com/denisidoro/navi) - Interactive cheatsheet tool for the command-line.
- [zoxide](https://github.com/ajeetdsouza/zoxide) - cd command that learns your habits.
- [pastefile](https://github.com/xyproto/pastefile) - Create a file that contains the contents from the clipboard.
- [ran](https://github.com/m3ng9i/ran) - Simple static web server written in Go.
- [watchexec](https://github.com/watchexec/watchexec) - Executes commands in response to file modifications.
- [procs](https://github.com/dalance/procs) - Modern replacement for ps written in Rust.
- [termdash](https://github.com/mum4k/termdash) - Terminal based dashboard.
- [yq](https://github.com/mikefarah/yq) - Portable command-line YAML processor.
- [squeeze](https://github.com/aymericbeaumet/squeeze) - Enables to extract rich information from any text (raw, JSON, HTML, YAML, etc).
- [amber](https://github.com/dalance/amber) - Code search / replace tool.
- [Pueue](https://github.com/Nukesor/pueue) - Daemon for managing long running shell commands.
- [mmv](https://github.com/itchyny/mmv) - Rename multiple files using your \$EDITOR.
- [jq](https://github.com/stedolan/jq) - Command-line JSON processor. ([Mastering JQ](https://codefaster.substack.com/p/mastering-jq-part-1-59c))
- [jq in Go](https://github.com/itchyny/gojq) - Pure Go implementation of jq.
- [faq](https://github.com/jzelinskie/faq) - Format Agnostic jQ.
- [gomi](https://github.com/b4b4r07/gomi) - Trash can in CLI.
- [jql](https://github.com/cube2222/jql) - Easy JSON Query Processor with a Lispy syntax in Go.
- [linkchecker](https://github.com/linkchecker/linkchecker) - Check links in web documents or full websites.
- [brok](https://github.com/smallhadroncollider/brok) - Find broken links in text documents. ([HN](https://news.ycombinator.com/item?id=22915834))
- [broot](https://github.com/Canop/broot) - New way to see and navigate directory trees.
- [chars](https://github.com/antifuchs/chars) - Display names and codes for various ASCII (and unicode) characters / code points.
- [diskus](https://github.com/sharkdp/diskus) - Minimal, fast alternative to du -sh.
- [glow](https://github.com/charmbracelet/glow) - Render markdown on the CLI, with pizzazz.
- [dtool](https://github.com/guoxbin/dtool) - Collection of development tools.
- [uni](https://github.com/arp242/uni) - Query the Unicode database from the commandline, with good support for emojis.
- [viu](https://github.com/atanunq/viu) - Command-line application to view images from the terminal written in Rust.
- [tealdeer](https://github.com/dbrgn/tealdeer) - Very fast implementation of tldr in Rust.
- [xcp](https://github.com/tarka/xcp) - Extended cp.
- [pazi](https://github.com/euank/pazi) - Fast autojump helper.
- [cbf](https://github.com/joshuatvernon/cbf) - Build custom CLI apps with only a json or yaml file.
- [rga](https://github.com/phiresky/ripgrep-all) - Ripgrep, but also search in PDFs, E-Books, Office documents, zip, tar.gz, etc.
- [hunter](https://github.com/rabite0/hunter) - Ranger-like file browser written in rust.
- [ytop](https://github.com/cjbassi/ytop) - TUI system monitor written in Rust.
- [noti](https://github.com/variadico/noti) - Monitor a process and trigger a notification.
- [ffsend](https://github.com/timvisee/ffsend) - Easily and securely share files from the command line. A fully featured Firefox Send client.
- [adns](https://www.gnu.org/software/adns/) - Advanced, easy to use, asynchronous-capable DNS client library and utilities.
- [advancecomp](https://github.com/amadvance/advancecomp) - Collection of recompression utilities for your .ZIP archives, .PNG snapshots, .MNG video clips and .GZ files.
- [ag](https://github.com/ggreer/the_silver_searcher) - Recursively search for pattern.
- [Antibody](https://github.com/getantibody/antibody) - Fastest shell plugin manager.
- [aria2A](https://github.com/aria2/aria2) - Lightweight multi-protocol & multi-source, cross platform download utility.
- [asciinema](https://asciinema.org/docs/usage) - Terminal session recorder.
- [asdf](https://github.com/asdf-vm/asdf) - Extendable version manager with support for Ruby, Node.js, Elixir, Erlang & more.
- [aspcud](https://potassco.org/aspcud/) - Solver for package dependencies.
- [automake](https://www.explainshell.com/explain/automake) - Automatically create Makefile.in's from Makefile.am's.
- [basename](https://www.explainshell.com/explain/basename) - Strip directory and suffix from filenames.
- [bash](https://www.explainshell.com/explain/bash) - GNU Bourne-Again SHell.
- [camlp4](https://github.com/ocaml/camlp4) - Software system for writing extensible parsers for programming languages.
- [ccat](https://github.com/jingweno/ccat) - Colorizing `cat`.
- [chroma](https://github.com/alecthomas/chroma) - General purpose syntax highlighter in pure Go.
- [chrome-cli](https://github.com/prasmussen/chrome-cli) - Control Google Chrome from the command line.
- [cmake](https://www.explainshell.com/explain/1/cmake) - Cross-platform makefile generator.
- [cowyo](https://github.com/schollz/cowyo) - Feature rich wiki webserver for minimalists.
- [croc](https://github.com/schollz/croc) - Easily get things from one computer to another.
- [ctop](https://github.com/bcicen/ctop) - Container metric viewer.
- [curl](https://www.explainshell.com/explain/curl) - Transfer a URL.
- [direnv](https://github.com/direnv/direnv) - Unclutter your .profile.
- [dirname](https://www.explainshell.com/explain/dirname) - Strip last component from file name.
- [docker](https://docs.docker.com/) - Self-sufficient runtime for containers.
- [entr](http://entrproject.org/) - Run arbitrary commands when files change. ([Article](https://jvns.ca/blog/2020/06/28/entr/)) ([Code](https://github.com/eradman/entr))
- [eisd](https://github.com/guidojo/eisd) - Execute your favorite command in SubDirectories.
- [fasd](https://github.com/clvv/fasd) - Quick access to files and directories.
- [fd](https://github.com/sharkdp/fd) - Simple, fast and user-friendly alternative to 'find'.
- [ffmpeg](https://www.explainshell.com/explain/ffmpeg) - Video converter.
- [fkill](https://github.com/sindresorhus/fkill-cli) - Kill processes.
- [friendly-find](https://github.com/sjl/friendly-find) - Usable replacement for find.
- [fzf](https://github.com/junegunn/fzf) - Command-line fuzzy finder.
- [fzy](https://github.com/jhawthorn/fzy) - Better fuzzy finder.
- [gdbm](https://www.gnu.org.ua/software/gdbm/) - Library of database functions that use extensible hashing and work similar to the standard UNIX dbm.
- [gifski](https://github.com/ImageOptim/gifski) - GIF encoder. Squeezes maximum possible quality from the awful GIF format.
- [gotty](https://github.com/yudai/gotty) - Share your terminal as a web application.
- [GraphicsMagick](http://www.graphicsmagick.org/) - Swiss army knife of image processing.
- [hask-replace](https://github.com/vmchale/hask-replace) - Command-line tool to rename modules in Haskell projects.
- [hexyl](https://github.com/sharkdp/hexyl) - Command-line hex viewer.
- [htttpie](https://httpie.org/) - HTTP client.
- [hyperfine](https://github.com/sharkdp/hyperfine) - Command-line benchmarking tool.
- [temci](https://github.com/parttimenerd/temci) - Advanced benchmarking tool written in Python 3 that supports setting up an environment for benchmarking and the generation of visually appealing reports.
- [imgur-screenshot](https://github.com/jomo/imgur-screenshot) - Take screenshot selection, upload to Imgur. + more cool things.
- [jq](https://stedolan.github.io/jq/) - Lightweight and flexible command-line JSON processor.
- [jump](https://github.com/gsamokovarov/jump) - Helps you navigate faster by learning your habits.
- [just](https://github.com/casey/just) - Handy way to save and run project-specific commands.
- [kubectl](https://kubernetes.io/docs/user-guide/kubectl-overview/) - Kubernetes cluster manager.
- [less](http://www.greenwoodsoftware.com/less/index.html) - Free, open-source file pager.
- [license-up](https://github.com/nikitavoloboev/license-up) - Create a license quickly for a given name.
- [LicGD](https://libgd.github.io/) - Open source code library for the dynamic creation of images by programmers.
- [loc](https://github.com/cgag/loc) - Count lines of code quickly.
- [mackup](https://github.com/lra/mackup) - Keep your application settings in sync (OS X/Linux).
- [make](https://www.explainshell.com/explain/make) - GNU make utility to maintain groups of programs.
- [massren](https://github.com/laurent22/massren) - Easily rename multiple files using your text editor.
- [mediumexporter](https://github.com/xdamman/mediumexporter) - Export medium.com articles to markdown.
- [moreutils](https://joeyh.name/code/moreutils/) - Growing collection of the unix tools that nobody thought to write long ago when unix was young.
- [mycli](https://github.com/dbcli/mycli) - Terminal Client for MySQL with AutoCompletion and Syntax Highlighting.
- [ncdu](https://dev.yorhel.nl/ncdu) - Disk usage analyzer with an ncurses interface.
- [neofetch](https://github.com/dylanaraps/neofetch) - Displays information about your operating system, software and hardware in an aesthetic and visually pleasing way.
- [ninja](https://ninja-build.org/) - Small build system with a focus on speed.
- [nm](https://www.explainshell.com/explain/nm) - Display name list (symbol table).
- [nmap](https://nmap.org/) - Network mapper.
- [pgcli](https://github.com/dbcli/pgcli) - Postgres CLI with autocompletion and syntax highlighting.
- [pkg](https://github.com/zeit/pkg) - Package your node.js project into an executable.
- [pngquant](https://pngquant.org/) - Command-line utility and a library for lossy compression of PNG images.
- [pspg](https://github.com/okbob/pspg) - Postgres Pager.
- [pv](https://github.com/icetee/pv) - Pipe Viewer.
- [rclone](https://rclone.org/docs/) - Rsync for cloud storage.
- [rename](http://plasmasturm.org/code/rename/) - Renames files according to modification rules specified on the command line.
- [scipy](https://github.com/scipy/scipy) - Open-source software for mathematics, science, and engineering.
- [scons](https://github.com/SCons/scons) - Software construction tool.
- [skim](https://github.com/lotabout/skim) - Fuzzy Finder in rust.
- [snallygaster](https://github.com/hannob/snallygaster) - Tool to scan for secret files on HTTP servers.
- [spark](https://zachholman.com/spark/) - Sparklines for your shell.
- [spotify-ripper](https://github.com/tmerten/spotify-ripper) - Rip Spotify URIs to MP3 files.
- [static-docs](https://github.com/apex/static) - General-purpose library, purpose-built commands for various domains.
- [stow](https://github.com/aspiers/stow) - Symlink farm manager program.
- [svgcleaner](https://github.com/RazrFalcon/svgcleaner) - Clean up your SVG files from the unnecessary data.
- [tar](https://www.explainshell.com/explain/tar) - Manipulate tape archives.
- [tin-summer](https://github.com/vmchale/tin-summer) - Find build artifacts that are taking up disk space.
- [tokei](https://github.com/Aaronepower/tokei) - Display statistics about your code. ([Reddit](https://www.reddit.com/r/rust/comments/hdr6gd/announcing_tokei_12_a_fast_accurate_code_analysis/))
- [visidata](https://github.com/saulpw/visidata) - Terminal spreadsheet multitool for discovering and arranging data.
- [vsce](https://code.visualstudio.com/docs/extensions/publish-extension) - Publish VS Code extensions.
- [warp](https://github.com/spolu/warp?attempt=8) - Secure and simple terminal sharing.
- [weather](https://github.com/jessfraz/weather) - Weather via the command line.
- [wego](https://github.com/schachmat/wego) - Weather app for the terminal.
- [wifi-password](https://github.com/rauchg/wifi-password) - Get wifi pass.
- [you-get](https://github.com/soimort/you-get) - Dumb downloader that scrapes the web.
- [dust](https://github.com/bootandy/dust) - More intuitive version of du in rust.
- [mdcat](https://github.com/lunaryorn/mdcat) - `cat` for Markdown.
- [exa](https://github.com/ogham/exa) - Replacement for ls written in Rust.
- [sd](https://github.com/chmln/sd) - Intuitive find & replace CLI.
- [ack](https://beyondgrep.com/documentation/) - Grep-like text finder.
- [alias](https://www.explainshell.com/explain/alias) - Define or display aliases.
- [apropos](https://www.explainshell.com/explain/apropos) - Search the manual page names and descriptions.
- [awk](https://www.explainshell.com/explain?cmd=awk) - Pattern-directed scanning and processing language.
- [bc](https://www.explainshell.com/explain/1/bc) - Arbitrary precision calculator language.
- [cat](https://www.explainshell.com/explain/cat) - Concatenate and print files.
- [cd](https://www.explainshell.com/explain/cd) - Change Directory.
- [chmod](https://www.explainshell.com/explain/chmod) - Change file mode bits.
- [cp](https://www.explainshell.com/explain/cp) - Copy files and directories.
- [cron](https://www.explainshell.com/explain/8/cron) - Daemon to execute scheduled commands.
- [cut](https://www.explainshell.com/explain/cut) - Cut out selected portions of each line of a file.
- [diff](https://www.explainshell.com/explain/1/diff) - Compare files line by line.
- [echo](https://www.explainshell.com/explain/echo) - Write arguments to the standard output.
- [env](https://www.explainshell.com/explain/env) - Set environment and execute command, or print environment.
- [file](https://www.explainshell.com/explain/file) - Determine file type.
- [find](https://www.explainshell.com/explain/1/find) - Walk a file hierarchy.
- [gnuplot](https://www.explainshell.com/explain/1/gnuplot) - Generate two and three dimensional plots of data.
- [grep](https://www.explainshell.com/explain/1/grep) - File pattern searcher.
- [head](https://www.explainshell.com/explain/head) - Output the first part of files.
- [jobs](https://ss64.com/bash/jobs.html) - Display status of jobs in the current session.
- [join](https://www.explainshell.com/explain/1/join) - Join lines of two files on a common field.
- [kill](https://www.explainshell.com/explain/1/kill) - Send a signal to a process.
- [killall](https://www.explainshell.com/explain/killall) - Kill processes by name.
- [ln](https://www.explainshell.com/explain/ln) - Create symbolic links.
- [ls](https://www.explainshell.com/explain/ls) - List directory contents.
- [lsof](https://www.explainshell.com/explain/lsof) - List open files.
- [man](https://www.explainshell.com/explain/1/man) - Open manual pages.
- [mv](https://www.explainshell.com/explain/mv) - Move (rename) files.
- [nice](https://www.explainshell.com/explain/1/nice) - Execute a utility with an altered scheduling priority.
- [nohup](https://www.explainshell.com/explain/nohup) - Run a command immune to hangups, with output to a non-tty.
- [paste](https://www.explainshell.com/explain/paste) - Merge lines of files.
- [rm](https://www.explainshell.com/explain/rm) - Remove directory entries.
- [rmdir](https://www.explainshell.com/explain/rmdir) - Remove empty directories.
- [scp](https://www.explainshell.com/explain/1/scp) - Secure copy (remote file copy program).
- [screen](https://www.explainshell.com/explain/1/screen) - Screen manager.
- [sed](https://www.explainshell.com/explain/sed) - Stream editor.
- [set](https://www.explainshell.com/explain/set) - Set or unset options and positional parameters.
- [sort](https://www.explainshell.com/explain/1/sort) - Put the lines of a text file in alphanumeric order.
- [split](https://www.explainshell.com/explain/1/split) - Split a file into pieces.
- [ssh](https://www.explainshell.com/explain/1/ssh) - Remote login.
- [strings](https://www.explainshell.com/explain/strings) - Print the strings of printable characters in files.
- [tail](https://www.explainshell.com/explain/tail) - Output the last part of files.
- [top](https://www.explainshell.com/explain/1/top) - Display and update sorted information about processes.
- [touch](https://www.explainshell.com/explain/touch) - Change file timestamps.
- [tr](https://www.explainshell.com/explain/tr) - Translate or delete characters.
- [tree](https://www.explainshell.com/explain/tree) - List contents of directories in a tree-like format.
- [type](https://www.explainshell.com/explain?cmd=type) - Describe a command.
- [uniq](https://www.explainshell.com/explain/uniq) - Report or omit repeated lines.
- [uptime](https://www.explainshell.com/explain/uptime) - Tell how long the system has been running.
- [wc](https://www.explainshell.com/explain/wc) - Print newline, word, and byte counts for each file.
- [whoami](https://www.explainshell.com/explain/whoami) - Print effective userid.
- [whois](https://www.explainshell.com/explain/whois) - Client for the whois directory service.
- [habitctl](https://github.com/blinry/habitctl) - Minimalist command line tool you can use to track and examine your habits.
- [jwt-cli](https://github.com/mike-engel/jwt-cli) - Super fast CLI tool to decode and encode JWTs built in Rust.
- [rtss](https://github.com/Freaky/rtss) - Relative TimeStamps for Stuff.
- [jc](https://github.com/kellyjonbrazil/jc) - Serializes the output of popular gnu linux command line tools and file types to structured JSON output. This allows piping of output to tools like jq.
- [psrecord](https://github.com/astrofrog/psrecord) - Record the CPU and memory activity of a process.
- [bottom](https://github.com/ClementTsang/bottom) - Cross-platform graphical process/system monitor with a customizable interface and a multitude of features.
- [undent](https://github.com/bradfitz/undent) - Unindent text/code.
- [misspell](https://github.com/client9/misspell) - Correct commonly misspelled English words in source files.
- [rargs](https://github.com/lotabout/rargs) - Kind of xargs + awk with pattern-matching support.
- [dupe-krill](https://github.com/kornelski/dupe-krill) - Fast file deduplicator.
- [fcat](https://github.com/mre/fcat) - Cat implementation in Rust. Only works on Linux.
- [lorem](https://github.com/per9000/lorem) - Python lorem ipsum generator.
- [miller](https://github.com/johnkerl/miller) - Like awk, sed, cut, join, and sort for name-indexed data such as CSV, TSV, and tabular JSON.
- [kickstart](https://github.com/Keats/kickstart) - Scaffolding tool to get new projects up and running quickly.
- [scc](https://github.com/boyter/scc) - Very fast accurate code counter with complexity calculations and COCOMO estimates.
- [gf](https://github.com/tomnomnom/gf) - Wrapper around grep, to help you grep for things.
- [godu](https://github.com/viktomas/godu) - Simple golang utility helping to discover large files/folders.
- [now](https://github.com/zeit/now) - Develop. Preview. Ship.
- [nomino](https://github.com/yaa110/nomino) - Batch rename utility for developers.
- [hex](https://github.com/sitkevij/hex) - Futuristic take on hexdump, made in Rust.
- [url-parser](https://github.com/herloct/url-parser) - Command-line URL parser, written in Go.
- [luneta](https://github.com/fbeline/luneta) - Interactive filter that can be easily composed within any script.
- [spin](https://github.com/egoist/spin) - Simple scaffolding tool.
- [as-tree](https://github.com/jez/as-tree) - Print a list of paths as a tree of paths.
- [wifi-password](https://github.com/bradyjoslin/wifi-password) - Quickly share Wi-Fi connection info.
- [delta](https://github.com/dandavison/delta) - Syntax-highlighter for git and diff output.
- [fzz](https://github.com/mrnugget/fzz) - Allows you to change the input of a single command interactively.
- [github-stats](https://github.com/umutphp/github-stats) - Command-line tool to get the total traffic statistics of your GitHub repositories.
- [map](https://github.com/soveran/map) - Map lines from stdin to commands.
- [JQL](https://github.com/yamafaktory/jql) - JSON Query Language CLI tool built with Rust.
- [jiq](https://github.com/fiatjaf/jiq) - jid on jq - interactive JSON query tool using jq expressions.
- [ijq](https://sr.ht/~gpanders/ijq) - Interactive jq tool. Like jqplay for the command line.
- [rex](https://sr.ht/~yerinalexey/rex) - Command line playground for regular expressions.
- [PWatch](https://github.com/VladimirMarkelov/pwatch) - Process Watcher.
- [Rdfind](https://github.com/pauldreik/rdfind) - Command line tool that finds duplicate files.
- [bfs](https://github.com/tavianator/bfs) - Breadth-first search for your files.
- [Choose](https://github.com/theryangeary/choose) - Human-friendly and fast alternative to awk and cut. ([HN](https://news.ycombinator.com/item?id=23427479))
- [yj](https://github.com/sclevine/yj) - Convert YAML <=> TOML <=> JSON <=> HCL.
- [buku](https://github.com/jarun/buku) - Browser-independent bookmark manager.
- [twf](https://github.com/wvanlint/twf) - Standalone tree view file explorer, inspired by fzf.
- [hostblock](https://github.com/cgag/hostblock) - Simple terminal interface for blocking websites via the /etc/hosts file.
- [ugrep](https://github.com/Genivia/ugrep) - Ultra fast grep with interactive query UI.
- [sad](https://github.com/ms-jpq/sad) - CLI search and replace. Show you a nice diff of proposed changes before you commit them.
- [wfh](https://github.com/kzys/wfh) - Continuously watches your local directories and rsync them against a remote host.
- [teip](https://github.com/greymd/teip) - Select partial standard input and replace with the result of another command.
- [Got](https://github.com/melbahja/got) - Simple and fast concurrent downloader.
- [duf](https://github.com/muesli/duf) - Disk Usage/Free Utility.
- [espanso](https://github.com/federico-terzi/espanso) - Cross-platform Text Expander written in Rust.
- [huniq](https://github.com/koraa/huniq) - Command line utility to remove duplicates from the given input. Note that huniq does not sort the input, it just removes duplicates.
- [RustScan](https://github.com/RustScan/RustScan) - Modern Port Scanner.
- [nat](https://github.com/willdoescode/nat) - Complete replacement for the 'ls' command.
- [csvq](https://github.com/mithrandie/csvq) - SQL-like query language for csv.
- [gping](https://github.com/orf/gping) - Ping, but with a graph.
- [FClones](https://github.com/pkolaczk/fclones) - Efficient Duplicate File Finder.
- [googler](https://github.com/jarun/googler) - Google from the terminal.
- [Proji](https://github.com/nikoksr/proji) - Powerful cross-platform CLI project templating tool.
- [dasel](https://github.com/TomWright/dasel) - Allows you to query and modify data structures using selector strings.
- [McFly](https://github.com/cantino/mcfly) - Fly through your shell history.
- [pbgopy](https://github.com/nakabonne/pbgopy) - Copy and paste between devices.
- [prism](https://github.com/muesli/prism) - RTMP stream recaster / splitter.
- [menyoki](https://github.com/orhun/menyoki) - Screen{shot,cast} and perform ImageOps on the command line. ([Web](https://menyoki.cli.rs/))
- [projen](https://github.com/projen/projen) - Define and maintain complex project configuration through code.
- [lsd](https://github.com/Peltoche/lsd) - Next gen ls command.
- [ls-lint](https://github.com/loeffel-io/ls-lint) - Extremely fast directory and filename linter - Bring some structure to your project directories. ([Docs](https://ls-lint.org/))
- [lychee](https://github.com/lycheeverse/lychee) - Fast, async, resource-friendly link checker written in Rust.
- [vgrep](https://github.com/vrothberg/vgrep) - User-friendly pager for grep.
- [urlhunter](https://github.com/utkusen/urlhunter) - Recon tool that allows searching on URLs that are exposed via shortener services.
- [rip](https://github.com/nivekuil/rip) - Safe and ergonomic alternative to rm.
- [Orderly](https://github.com/andrewchambers/orderly) - Tool that provides ordered and controlled start, stop, restart and cleanup of a group of processes.
- [Ruplacer](https://github.com/TankerHQ/ruplacer) - Find and replace text in source files.
- [Graphtage](https://github.com/trailofbits/graphtage) - Semantic diff utility and library for tree-like files such as JSON, JSON5, XML, HTML, YAML, and CSV.
- [sq](https://github.com/neilotoole/sq) - Command line tool that provides jq-style access to structured data sources such as SQL databases, or document formats like CSV or Excel. ([Web](https://sq.io/))
- [yank](https://github.com/mptre/yank) - Yank terminal output to clipboard. ([HN](https://news.ycombinator.com/item?id=26608233))
- [xplr](https://github.com/sayanarijit/xplr) - Hackable, minimal, fast TUI file explorer, stealing ideas from nnn and fzf.
- [Freshfetch](https://github.com/K4rakara/freshfetch) - Fresh take on Neofetch.
- [rush](https://github.com/shenwei356/rush) - Cross-platform command-line tool for executing jobs in parallel.
- [so](https://github.com/samtay/so) - Terminal interface for Stack Overflow.
- [gdu](https://github.com/dundee/gdu) - Disk usage analyzer with console interface written in Go.
- [kalk](https://github.com/PaddiM8/kalk) - Command line calculator that supports math-like syntax with user-defined variables, functions, derivation, integration, and complex numbers. ([Web](https://kalk.strct.net/)) ([HN](https://news.ycombinator.com/item?id=27333772))
- [fcp](https://github.com/Svetlitski/fcp) - Significantly faster alternative to the classic Unix cp command.
- [Renamer](https://github.com/innocenzi/rename) - Command line utility to batch-rename files via your editor.
- [Difftastic](https://github.com/Wilfred/difftastic) - Syntax-aware structured diff tool. ([HN](https://news.ycombinator.com/item?id=27768861))
- [hck](https://github.com/sstadick/hck) - Drop in replacement for cut that can use a regex delimiter instead of a fixed string.
- [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) - Calendar heatmap inspired by GitHub contribution activity.
- [rnr](https://github.com/ChuckDaniels87/rnr) - Command-line tool to batch rename files and directories.
- [Gaze](https://github.com/wtetsu/gaze) - Runs a command, right after you save a file.
- [Czkawka](https://github.com/qarmin/czkawka) - Multi functional app to find duplicates, empty folders, similar images etc.
- [Rustcat](https://github.com/robiot/rustcat) - Netcat Alternative in Rust.
- [s](https://github.com/zquestz/s) - Web search from the terminal. Just opens in your browser.
- [Sweep](https://github.com/woubuc/sweep) - Reduce the disk usage of your projects by removing dependencies & builds.
- [Viddy](https://github.com/sachaos/viddy) - Modern watch command. Time machine and pager etc.
- [tree-grepper](https://github.com/BrianHicks/tree-grepper) - Like grep, but uses tree-sitter grammars to search.
- [qq](https://github.com/mattn/qq) - Select stdin with query.
- [todocheck](https://github.com/preslavmihaylov/todocheck) - Static code analyzer for annotated TODO comments.
- [TV](https://github.com/alexhallam/tv) - Cross-platform CSV pretty printer made to maximize viewer enjoyment. ([HN](https://news.ycombinator.com/item?id=28670252))
- [anew](https://github.com/tomnomnom/anew) - Tool for adding new lines to files, skipping duplicates.
- [hors](https://github.com/WindSoilder/hors) - Instant coding answers via the command line.

## Related

- [Awesome CLI apps](https://github.com/aharris88/awesome-cli-apps)
- [Awesome command line apps](https://github.com/herrbischoff/awesome-command-line-apps)
- [Awesome shell](https://github.com/alebcay/awesome-shell)
- [Structured text tools](https://github.com/dbohdan/structured-text-tools) - List of text-based file formats and command line tools for manipulating each.

[![CC4](https://img.shields.io/badge/license-CC4-0a0a0a.svg?style=flat&colorA=0a0a0a)](https://creativecommons.org/licenses/by/4.0/)
[![Lists](https://img.shields.io/badge/-more%20lists-0a0a0a.svg?style=flat&colorA=0a0a0a)](https://github.com/learn-anything/curated-lists)
[![Contribute](https://img.shields.io/badge/-contribute-0a0a0a.svg?style=flat&colorA=0a0a0a)](contributing.md)
[![Twitter](http://bit.ly/latwitt)](https://twitter.com/learnanything_)
